/*
Welcome to Gunbuddy's SEXY LAZER BEAM DEMO!

What this demo does it create a continuous beam that allows you to create the illusion of 2 entities being tethered together.
It takes the source atom and draws the beam to the target

Currently, the Beam() proc will only allow one beam to come from a source at a time.  Attempting to call it more than once at a time per source
will cause graphical errors.

Also, the icon used for the beam will have to be vertical and 32x32, as in the provided example icons.
The math involved assumes that the icon is vertical to begin with so unless you want to adjust the math, its easier to just keep the beam vertical.


In order to use the Beam proc, just copy/past the contents of BeamLibrary.dm into your game.
After that, all you need to do is call it with a target and any of the optional arguements which are commented in this file

*/
world
	maxx=15
	maxy=15
	turf=/turf
	New()
		..()
		new/mob/enemy(locate(rand(5,10),rand(5,10),1))		//Places a mob randomly so there is something to use the beam on.
turf
	icon='Icons.dmi'
	icon_state="turf"
mob/enemy
	icon='Icons.dmi'
	icon_state="enemy"
	var/moving=0
mob
	icon='Icons.dmi'
	icon_state="mob"

	verb/GreenBeam()
		for(var/mob/enemy/Target in orange(10,src))
			spawn() Beam(Target,50,'GreenBeam.dmi')		//Calls the Beam proc, connecting the player to the Target for 50 ticks (5 seconds)
														//and using the 'GreenBeam.dmi' icon for the beam.
			break										//And then it breaks out of the loop to prevent it from running another beam on another target.

	verb/BlueBeam()
		for(var/mob/enemy/Target in orange(10,src))
			spawn() Beam(Target,50,'BlueBeam.dmi')		//Same as GreenBeam command, just with a different icon.
			break

	verb/RedBeam()
		for(var/mob/enemy/Target in orange(10,src))
			spawn() Beam(Target,50,'RedBeam.dmi')		//Same as GreenBeam command, just with a different icon.
			break

	verb/Walk()											//This command is just to show that the beam will continue to work even if the Target is moving.
		for(var/mob/enemy/Target in orange(10,src))
			Target.moving=1-Target.moving
			if(Target.moving) walk_rand(Target,3)
			else walk(Target,0)


/*atom/proc/Beam(atom/BeamTarget,time=50,icon='GreenBeam.dmi',maxdistance=10)
															//BeamTarget represents the target for the beam, basically just means the other end.
															//Time is the duration to draw the beam
															//Icon is obviously which icon to use for the beam, default is GreenBeam.dmi
															//Maxdistance is the longest range the beam will persist before it gives up.
	var/EndTime=world.time+time
	while(BeamTarget&&world.time<EndTime&&get_dist(src,BeamTarget)<maxdistance&&z==BeamTarget.z)
															//If the BeamTarget gets deleted, the time expires, or the BeamTarget gets out
															//of range or to another z-level, then the beam will stop.  Otherwise it will
															//continue to draw.


		dir=get_dir(src,BeamTarget)				//Optional, this causes the source of the beam to rotate to continuosly face the
												///BeamTarget.  You can remove this line if you don't want the source to rotate, or you

		for(var/obj/beam/O in orange(10,src))		//This section erases the previously drawn beam because I found it was easier to
			if(O.BeamSource==src)					//just draw another instance of the beam instead of trying to manipulate all the
				del O								//pieces to a new orientation.
		var/Angle=round(Get_Angle(src,BeamTarget))
		var/icon/I=new(icon)
		I.Turn(Angle)
		var/DX=(32*BeamTarget.x+BeamTarget.pixel_x)-(32*x+pixel_x)
		var/DY=(32*BeamTarget.y+BeamTarget.pixel_y)-(32*y+pixel_y)
		var/N=0
		var/length=round(sqrt((DX)**2+(DY)**2))
		for(N,N<length,N+=32)
			var/obj/beam/X=new(loc)
			X.BeamSource=src
			if(N+32>length)
				var/icon/II=new(icon)
				II.DrawBox(null,1,(length-N),32,32)
				II.Turn(Angle)
				X.icon=II
			else X.icon=I
			var/Pixel_x=round(sin(Angle)+32*sin(Angle)*(N+16)/32)
			var/Pixel_y=round(cos(Angle)+32*cos(Angle)*(N+16)/32)
			if(DX==0) Pixel_x=0
			if(DY==0) Pixel_y=0
			if(Pixel_x>32)
				for(var/a=0, a<=Pixel_x,a+=32)
					X.x++
					Pixel_x-=32
			if(Pixel_x<-32)
				for(var/a=0, a>=Pixel_x,a-=32)
					X.x--
					Pixel_x+=32
			if(Pixel_y>32)
				for(var/a=0, a<=Pixel_y,a+=32)
					X.y++
					Pixel_y-=32
			if(Pixel_y<-32)
				for(var/a=0, a>=Pixel_y,a-=32)
					X.y--
					Pixel_y+=32
			X.pixel_x=Pixel_x
			X.pixel_y=Pixel_y
		sleep(3)	//Changing this to a lower value will cause the beam to follow more smoothly with movement, but it will also be more laggy.
					//I've found that 3 ticks provided a nice balance for my use.
	for(var/obj/beam/O in orange(10,src)) if(O.BeamSource==src) del O

proc/Get_Angle(atom/movable/start,atom/movable/end)						//This proc determines the angle between the BeamSource and the BeamTarget.
	if(!start || !end) return 0
	var/dy
	var/dx
	dy=(32*end.y+end.pixel_y)-(32*start.y+start.pixel_y)
	dx=(32*end.x+end.pixel_x)-(32*start.x+start.pixel_x)
	if(!dy)
		return (dx>=0)?90:270
	.=arctan(dx/dy)
	if(dy<0)
		.+=180
	else if(dx<0)
		.+=360

proc/arctan(x)
	var/y=arcsin(x/sqrt(1+x*x))
	return y
*/